Subject: Re: [PATCH net-next v2] net/smc: fix compile warning for smc_sysctl

From: "dust.li" <[email-masked]>
Date: Sun, 6 Mar 2022 22:27:08 +0800

On Fri, Mar 04, 2022 at 09:31:51PM -0800, Jakub Kicinski wrote:
>On Thu,  3 Mar 2022 16:40:06 +0800 Dust Li wrote:
>> kernel test robot reports multiple warning for smc_sysctl:
>> 
>>   In file included from net/smc/smc_sysctl.c:17:
>> >> net/smc/smc_sysctl.h:23:5: warning: no previous prototype \  
>> 	for function 'smc_sysctl_init' [-Wmissing-prototypes]
>>   int smc_sysctl_init(void)
>>        ^
>> and
>>   >> WARNING: modpost: vmlinux.o(.text+0x12ced2d): Section mismatch \  
>>   in reference from the function smc_sysctl_exit() to the variable
>>   .init.data:smc_sysctl_ops
>>   The function smc_sysctl_exit() references
>>   the variable __initdata smc_sysctl_ops.
>>   This is often because smc_sysctl_exit lacks a __initdata
>>   annotation or the annotation of smc_sysctl_ops is wrong.
>> 
>> and
>>   net/smc/smc_sysctl.c: In function 'smc_sysctl_init_net':
>>   net/smc/smc_sysctl.c:47:17: error: 'struct netns_smc' has no member named 'smc_hdr'
>>      47 |         net->smc.smc_hdr = register_net_sysctl(net, "net/smc", table);
>> 
>> Since we don't need global sysctl initialization. To make things
>> clean and simple, remove the global pernet_operations and
>> smc_sysctl_{init|exit}. Call smc_sysctl_net_{init|exit} directly
>> from smc_net_{init|exit}.
>> 
>> Also initialized sysctl_autocorking_size if CONFIG_SYSCTL it not
>> set, this makes sure SMC autocorking is enabled by default if
>> CONFIG_SYSCTL is not set.
>
>I think that makes sense, one nit below.
>
>> -static __net_init int smc_sysctl_init_net(struct net *net)
>> +int smc_sysctl_net_init(struct net *net)
>>  {
>>  	struct ctl_table *table;
>>  
>> @@ -59,22 +59,7 @@ static __net_init int smc_sysctl_init_net(struct net *net)
>>  	return -ENOMEM;
>>  }
>>  
>> -static __net_exit void smc_sysctl_exit_net(struct net *net)
>> +void smc_sysctl_net_exit(struct net *net)
>>  {
>>  	unregister_net_sysctl_table(net->smc.smc_hdr);
>>  }
>
>> +int smc_sysctl_net_init(struct net *net);
>> +void smc_sysctl_net_exit(struct net *net);
>
>I believe these functions can become / remain __net_init and __net_exit,
>since all the callers are also marked as such.

Agree, I will add this in the next version.

>
>>  #else
>>  
>> -int smc_sysctl_init(void)
>> +static inline int smc_sysctl_net_init(struct net *net)
>>  {
>> +	net->smc.sysctl_autocorking_size = SMC_AUTOCORKING_DEFAULT_SIZE;
>>  	return 0;
>>  }
>>  
>> -void smc_sysctl_exit(void) { }
>> +static inline void smc_sysctl_net_exit(struct net *net) { }
>
>Doesn't matter for static inlines.

OK

Thanks for you advice

>
>>  #endif /* CONFIG_SYSCTL */
>>